<?php if($action == 'add'):?>
    <!-- Add posts form or functionality here -->
    <div class="w-50 mx-auto">
        <form method="POST" action="<?=ROOT?>/admin/posts/add" enctype="multipart/form-data">
            <h1 class="h3 mb-3 fw-normal">Create Post</h1>

            <!-- Error Messages -->
            <?php if (!empty($errors)): ?>
                <div class="alert alert-danger">
                    <ul>
                        <?php foreach ($errors as $error): ?>
                            <li><?= $error ?></li>
                        <?php endforeach; ?>
                    </ul>
                </div>
            <?php endif; ?>

            <div class="alert alert-danger d-none" id="alert">
                <ul id="error-list"></ul>
            </div>

                    <!-- Image Upload -->
                    <div class="text-center">
                        <label class="form-label fw-bold">Post Image</label>
                        <div class="mb-3">
                            <input type="file" name="image" id="imageUpload" class="form-control" accept="image/*">
                        </div>
                        <div class="mb-3">
                            <img id="previewImage" 
                                src="<?= !empty($user['image']) ? get_image($user['image']) : '' ?>" 
                                class="img-thumbnail rounded-circle shadow-sm" 
                                style="width: 120px; height: 120px; object-fit: cover; <?= !empty($user['image']) ? '' : 'display: none;' ?>">
                        </div>
                        <canvas id="croppedCanvas" style="display: none;"></canvas>
                    </div>

                    <input type="hidden" name="cropped_image" id="croppedImageData">

            <!-- Title -->
            <div class="form-floating mt-5">
                <input value="<?oldvalue('title')?>" type="text" name="title" class="form-control" id="floatingInput" placeholder="Title" required>
                <label for="floatingInput">Title</label>
            </div>

            <!-- Content -->
            <div class="mt-3">
                <textarea id="customTextarea" name="content" rows="4" class="form-control custom-textarea" placeholder="Your message"><?oldvalue('content')?></textarea>
            </div>

            <!-- Category -->
            <div class="form-floating mt-3">
                <?php
                $query = "SELECT * FROM categories WHERE active=1";
                $categories = query($query);
                ?>
                <select id="dropdown1" class="form-select" name="category_id">
                    <option value="">Select Category</option>
                    <?php foreach ($categories as $category): ?>
                        <option value="<?= $category['id'] ?>"><?= $category['category'] ?></option>
                    <?php endforeach; ?>
                </select>
                <label for="dropdown1">Category</label>
            </div>

            <!-- Buttons -->
            <div class="d-flex justify-content-between mt-3">
                <a href="<?=ROOT?>/admin/users" class="btn btn-secondary py-2 px-4">Back</a>
                <button class="btn btn-primary py-2 px-4" type="submit">Add</button>
            </div>
        </form>
    </div>
                   
<?php elseif($action == 'edit'):?>
    <!-- Edit posts form or functionality here -->
    <?php
    $edit_id=$url[3] ?? '';
        $query="SELECT * FROM posts where id=:id and active=1";
        $posts=query_row($query,['id'=>$edit_id]);
        if($posts){
    ?>
        <div class="w-50 mx-auto"> 
        <form method="POST" action="<?=ROOT?>/admin/posts/edit/<?=$posts['id']?>" enctype="multipart/form-data">
        <h1 class="h3 mb-3 fw-normal">Edit posts</h1>
        <?php
        if(!empty($errors))
        {
        echo '<div class="alert alert-danger">';
        echo '<ul>';
        foreach($errors as $error)
        {
            echo '<li>'.$error.'</li>';
        }
        echo '</ul>';
        echo '</div>';
        }
        ?>
        <input type="hidden" name="id" value="<?=$posts['id']?>">
        <div class="alert alert-danger d-none" id="alert">
        <ul id="error-list">
        </ul>
        </div>

            <!-- Image Upload + Cropper Preview -->
            <div class="mb-3">
                <input type="file" name="image" id="imageUpload" accept="image/*">
            </div>

            <div class="mb-3">
            <img id="previewImage" 
                src="<?= !empty($posts['image']) ? get_image($posts['image']) : '' ?>" 
                class="img-thumbnail" 
                style="max-width: 100%; <?= !empty($posts['image']) ? '' : 'display: none;' ?>">
            </div>

            <div class="mb-3">
                <canvas id="croppedCanvas" style="display: none;"></canvas>
            </div>

            <input type="hidden" name="cropped_image" id="croppedImageData">

    
        <!-- <label class="upload-container mx-auto text-center">
        <input type="file" name="image" id="imageUpload" accept="image/*" onchange="previewSelectedImage(event)">
        <img id="previewImage" src="<?=get_image($posts['image'])?>" class="img-thumbnail mx-auto">
        </label> -->

        <div class="form-floating">
        <input value="<?=oldvalue('title',$posts['title'])?>" 
           type="text" name="title" class="form-control" id="floatingInput" 
           placeholder="name@example.com" required>
        <label for="floatingInput">Title</label>
        </div>

        <div class="mt-3">
        <textarea id="customTextarea" name="content" rows="4" class="form-control custom-textarea" placeholder="Your message"><?oldvalue('content',$posts['content'])?></textarea>
        </div>


        <div class="form-floating">
        <?php
        $query="SELECT * FROM categories where active=1";
        $categories=query($query);
        ?>
        <select id="dropdown1" class="form-select mt-3 mb-3" name="category_id">
            <option value="">Select Category</option>
            <?php foreach($categories as $category):?>
            <option value="<?=$category['id']?>" <?= ($posts['category_id'] == $category['id']) ? "selected" : "" ?> ><?=$category['category']?></option>
            <?php endforeach;?>
        </select>
        <label for="floatingInput">Category</label>
        </div> 

        <div class="d-flex justify-content-between mt-3">
        <a href="<?=ROOT?>/admin/posts" class="btn btn-secondary py-2 px-4">Back</a>
        <button class="btn btn-primary py-2 px-4" type="submit">Save</button>
        </div>

        </form>
    </div>
    <?php }
    else{
        echo '<div class="alert alert-danger">posts not found</div>';
        echo '<a href="'.ROOT.'/admin/posts" class="btn btn-primary">Back to posts</a>';
    }
    ?>     
<?php elseif($action == 'delete'):?> 
    <!-- Delete posts functionality here -->
    <?php
    echo "Delete posts";
   echo $delete_id=$url[3];
    $query="SELECT * FROM posts where id=:id and active=1";
    $posts1=query_row($query,['id'=>$delete_id]);
    if(!$posts1){
        echo '<div class="alert alert-danger">posts not found</div>';
        echo '<a href="'.ROOT.'/admin/posts" class="btn btn-primary">Back to Posts</a>';
        die;
    }else{
        $query="UPDATE posts SET active=0 where id=:id";
        $posts=query($query,['id'=>$delete_id]);
        if(file_exists('/home/Iamrajesh/htdocs/blogs/public'.$posts['image'])){
            unlink('/home/Iamrajesh/htdocs/blogs/public'.$posts['image']);
        }
        ?>
        <div class="alert alert-success">Post deleted successfully</div>
        <a href="<?=ROOT?>/admin/posts" class="btn btn-primary">Back to Posts</a>
        <?php
    }
    ?>
<?php else:?>    
    <!-- List all posts here -->
    <div class="table-responsive">    
        <table class="table table-striped">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Title</th>
                    <th>Content</th>
                    <th>Slug</th>
                    <th>Image</th>
                    <th>Date</th>
                    <th>Action</th>
                </tr>
            </thead>
            <?php  
            $limit=3;
            $offset=($PAGE['page_number']-1)*$limit;
            $query="SELECT * FROM posts where active=1 order by id desc limit $limit offset $offset";
            $posts=query($query);
            ?>
            <tbody>
                <?php if(!empty($posts)):?>
                    <?php foreach ($posts as $posts): ?>
                        <tr class="align-middle">
                            <td><?=$posts['id']?></td>
                            <td><?=esc($posts['title'])?></td>
                            <td><?=esc($posts['content'])?></td>
                            <td><?=$posts['slug']?></td>
                             <td>
                            <img src="<?=get_image($posts['image'])?>" class="img-thumbnail" width="100" height="100">
                            </td>
                            <td><?= date('d-m-Y', strtotime($posts['date'])) ?></td>
                            <td>
                                <a href="<?=ROOT?>/admin/posts/edit/<?=$posts['id']?>" class="btn btn-primary"><i class="bi bi-pencil-square"></i></a>
                                <a data-bs-toggle="modal" data-bs-target="#deleteModal" class="btn btn-danger"><i class="bi bi-trash"></i></a>
                                <div class="modal fade" id="deleteModal" tabindex="-1" aria-labelledby="deleteModalLabel" aria-hidden="true">
                                <div class="modal-dialog modal-dialog-centered">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title" id="deleteModalLabel">Confirm Deletion</h5>
                                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                        </div>
                                        <div class="modal-body text-center">
                                            <p>Do you want to delete this Post?</p>
                                        </div>
                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                                            <a href="<?=ROOT?>/admin/posts/delete/<?=$posts['id']?>" class="btn btn-danger">Delete</a>
                                        </div>
                                    </div>
                                </div>
                                </div> 
                           </td>
                        </tr>
                    <?php endforeach; ?>
                <?php endif; ?>
            </tbody>
        </table>

        <div class="col-md-12 d-flex justify-content-center gap-2 mt-3 mb-3">
            <a href="<?=$PAGE['first_link']?>" class="btn btn-primary">First Page</a>
            <a href="<?=$PAGE['prev_link']?>" class="btn btn-primary">Previous</a>
            <a href="<?=$PAGE['next_link']?>" class="btn btn-primary">Next</a>
        </div>
    </div>
<?php endif; ?>
