<? include 'includes/header.php';?>

<!-- CSS for Dynamic Light/Dark Mode Text Colors -->
<style>
    /* Default Light Mode (Black Text) */
    .username-link, .comment-text {
        color: black;
    }

    /* Dark Mode (White Text) */
    [data-bs-theme="dark"] .username-link,
    [data-bs-theme="dark"] .comment-text {
        color: white !important;
    }
</style>


<?php

if(!empty($_POST['comment']) && ($_POST['postid']) && ($_POST['userid'])){
    $data['userid'] = $_POST['userid'];
    $data['postid'] = $_POST['postid'];
    $data['comment'] = $_POST['comment'];


    $data['date'] = date('Y-m-d H:i:s'); 
    $query = "INSERT INTO comments(user_id,post_id,comment,date) values(:userid,:postid,:comment,:date)";
    query($query,$data); 
}
if(!empty($_POST['edited_comment']) && ($_POST['comment_id'])){
    $data['comment_id'] = $_POST['comment_id'];
    $data['edited_comment'] = $_POST['edited_comment'];
    $query = "UPDATE comments set comment = :edited_comment where id = :comment_id";
    query($query,$data); 
}
if(!empty($_POST['del_comment_id'])){
    $data['del_comment_id'] = $_POST['del_comment_id'];
    $query = "UPDATE comments set active = 0 where id = :del_comment_id";
    query($query,$data); 
}


$slug = $url[1] ?? null;
if ($slug) {
    $query = "SELECT posts.*, categories.category, users.username, users.image as image_user ,users.id as userid
              FROM posts 
              JOIN categories ON posts.category_id = categories.id
              JOIN users ON posts.user_id = users.id
              WHERE posts.active = 1 and posts.slug=:slug limit 1;";
    $result = query($query, ['slug' => $slug]);   
}
if($result){
    ?>
    <?php foreach ($result as $post): 
        $id = $post['id'];
        $title = $post['title'];
        $content = $post['content'];
        $image = $post['image'];
        $category = $post['category'];
        $username = $post['username'];
        $image_user = $post['image_user'];
        $userid = $post['userid'];

        $date = timepicker($post['date']);
        ?>
<div class="container mt-5 mb-5">
    <div class="row featurette">
        <div class="col-12">
            <div class="card border rounded shadow-lg p-4" style="max-width: 1200px; margin: auto;">
                <div class="row">
                    
                    <!-- Post Image -->
                    <div class="col-md-6 order-md-1 order-1">
                        <img src="<?= get_image($image) ?>" 
                             class="bd-placeholder-img bd-placeholder-img-lg featurette-image img-fluid mx-auto border rounded"
                             style="width: 100%; height: auto; object-fit: cover;">
                    </div>

                    <!-- Post Content -->
                    <div class="col-md-6 order-md-2 order-2 text-center text-md-start mt-md-4 d-flex flex-column justify-content-between">
                        <div>
                            <h2 class="featurette-heading fw-bold lh-1 fs-1 mt-5">
                                <?= $title ?>
                            </h2>
                            
                            <!-- Category Display -->
                            <div class="mt-3">
                                <span class="badge bg-primary fs-6 px-3 py-2 shadow-sm">
                                    <i class="bi bi-tags"></i> <?= $category ?>
                                </span>
                            </div>

                            <!-- Post Content -->
                            <p class="lead fs-4 text-dark mt-3">
                                <?= $content ?>               
                            </p>
                        </div>

                        <!-- Posted by section -->
                        <div class="d-flex align-items-center p-2 text-dark" style="background-image: linear-gradient(to top,rgb(166, 210, 241) 0%,#0d6efd 100%);">
                            <a href="<?=ROOT?>/profile/<?=$userid?>" class="d-flex align-items-center">
                                <img src="<?=get_image($image_user)?>" alt="User Image" 
                                     class="img-fluid rounded-circle border me-2 shadow-sm" 
                                     style="width: 45px; height: 45px; object-fit: cover;">
                            </a>
                            <div>
                                <small class="fs-6">
                                    Posted by <strong><a class="text-decoration-none text-dark" href="<?=ROOT?>/profile/<?=$userid?>"><?= $username ?></a></strong> 
                                    • <?= $date ?>
                                </small>
                            </div>
                        </div>
                    </div>
                </div>

                  <!-- Liked By Section -->
                <div class="mt-4">
                    <h5 class="fw-bold">Liked by</h5>
                    <div class="liked-by border rounded p-3 bg-light d-flex flex-wrap align-items-center justify-content-start gap-2">
                        <?php
                        $like_query = "SELECT users.id, users.username, users.image FROM likes 
                                        JOIN users ON likes.user_id = users.id 
                                        WHERE likes.post_id = $id 
                                        LIMIT 3"; // Limit to 3 users for a clean UI
                        $liked_users = query($like_query);

                        if (!empty($liked_users)): 
                            foreach ($liked_users as $user): ?>
                                <a href="<?= ROOT ?>/profile/<?= $user['id'] ?>" class="d-flex align-items-center text-decoration-none">
                                    <img src="<?= get_image($user['image']) ?>" alt="User Image" class="rounded-circle border shadow-sm me-1"
                                        style="width: 30px; height: 30px; object-fit: cover;">
                                    <span class="fw-bold text-primary"><?= htmlspecialchars($user['username']) ?></span>
                                </a>
                            <?php endforeach;

                            if (count($liked_users) >= 3): ?>
                                <span class="text-muted">and others</span>
                            <?php endif;
                        else:
                            echo '<p class="mb-0 text-muted">Be the first to like this!</p>';
                        endif;
                        ?>
                    </div>
                </div>




                <!-- Comment Section -->
                <div class="mt-4">
                    <h5 class="fw-bold">Comments</h5>
                    <div class="comments-section border rounded p-3 text-body back bg-secondary" data-bs-theme="dark">
                    <?php
                    $query1 = "SELECT comments.*, a.username, a.image AS user_image, a.id AS comment_user_id 
                            FROM comments 
                            JOIN users AS a ON comments.user_id = a.id 
                            WHERE comments.active = 1 AND comments.post_id = $id";
                    $comments = query($query1);
                    ?>
                    
                    <?php foreach ($comments as $comment): ?>
                        <div class="d-flex align-items-start mb-3">
                            <a class="text-decoration-none" href="<?=ROOT?>/profile/<?=$comment['user_id']?>"> 
                                <img src="<?= get_image($comment['user_image']) ?>" class="rounded-circle border me-2 shadow-sm" 
                                    style="width: 40px; height: 40px; object-fit: cover;">
                            </a>
                            <div class="flex-grow-1">
                                <a class="text-decoration-none text-dark" href="<?=ROOT?>/profile/<?=$comment['user_id']?>"> 
                                    <strong><?= $comment['username'] ?></strong>
                                </a>
                                
                                <p class="mb-1 text-dark comment-text" id="comment-text-<?= $comment['id'] ?>">
                                    <?= $comment['comment'] ?>
                                </p>
                                
                                <!-- Edit Form (Initially Hidden) -->
                                <div id="edit-form-<?= $comment['id'] ?>" class="d-none edit-comment-form" data-id="<?= $comment['id'] ?>">
                                    <form action="" method="POST">
                                        <input type="hidden" name="comment_id" value="<?= $comment['id'] ?>">
                                        <input type="text" name="edited_comment" class="form-control" value="<?= $comment['comment'] ?>">
                                        <button type="submit" class="btn btn-success btn-sm mt-2">Save</button>
                                        <button type="button" class="btn btn-success btn-sm cancel-edit mt-2">Cancel</button>

                                    </form>
                                </div>
                                
                                <small class="text-dark"> <?= timepicker($comment['date']) ?> </small>
                            </div>
                            
                            <?php if ($comment['user_id'] == $_SESSION['user_id'] || $userid == $_SESSION['user_id']): ?>
                                <div class="ms-2">
                                    <?php if ($comment['user_id'] == $_SESSION['user_id']):?>
                                    <button class="btn btn-sm btn-outline-primary edit-btn" data-id="<?= $comment['id'] ?>">
                                        <i class="bi bi-pencil"></i>
                                    </button>
                                    <?php endif;?>
                                    <button class="btn btn-sm btn-outline-danger delete-btn" data-bs-toggle="modal" 
                                            data-bs-target="#deleteCommentModal-<?= $comment['id'] ?>">
                                        <i class="bi bi-trash"></i>
                                    </button>
                                </div>
                            <?php endif; ?>
                        </div>
                        
                        <!-- Delete Modal -->
                        <div class="modal fade" id="deleteCommentModal-<?= $comment['id'] ?>" tabindex="-1" aria-hidden="true">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title">Delete Comment</h5>
                                        <button type="button" class="btn-close" data-bs-dismiss="modal"></button>
                                    </div>
                                    <div class="modal-body"> Are you sure you want to delete this comment? </div>
                                    <div class="modal-footer">
                                        <form action="" method="POST">
                                            <input type="hidden" name="del_comment_id" value="<?= $comment['id'] ?>">
                                            <button type="submit" class="btn btn-danger">Delete</button>
                                        </form>
                                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    <?php endforeach; ?>
                </div>



                    <?php $userimage = find('users', $_SESSION['user_id'], 'image'); ?>

                    <!-- Comment Input -->
                    <form action="" method="POST" class="d-flex align-items-center mt-3">
                        <img src="<?= get_image($userimage) ?>" class="rounded-circle border me-2 shadow-sm"
                            style="width: 40px; height: 40px; object-fit: cover;">
                        <input type="text" name="comment" class="form-control rounded-pill shadow-sm bg-body text-body" 
                            placeholder="Add a comment..." required>
                        <input type="hidden" value="<?=$_SESSION['user_id']?>" name="userid">
                        <input type="hidden" value="<?=$id?>" name="postid">
                        <button type="submit" class="btn btn-primary rounded-pill ms-2 px-3 py-1">
                            <i class="bi bi-send"></i>
                        </button>
                    </form>
                </div>

                <!-- Edit & Delete Buttons -->
                <?php if($userid == $_SESSION['user_id']): ?>
                <div class="text-left mt-3">
                    <a href="<?=ROOT?>/user/post/edit/<?=$id?>" class="btn btn-outline-primary px-3 py-2 shadow-sm">
                        <i class="bi bi-pencil"></i> Edit Post
                    </a>
                    <a data-bs-toggle="modal" data-bs-target="#deleteModal" class="btn btn-outline-danger px-3 py-2 shadow-sm">
                        <i class="bi bi-trash"></i> Delete Post
                    </a>
                </div>
                <?php endif; ?>
            </div> 
        </div>
    </div>
</div>

    <?php endforeach;?>     

<?
    }
    
else{
    echo '<div class="alert alert-danger">Post not found</div>';
    echo '<a href="'.ROOT.'/blog" class="btn btn-primary">Back to Blogs</a>';
}

?>  
<!-- Delete Confirmation Modal -->
<div class="modal fade" id="deleteModal" tabindex="-1" aria-labelledby="deleteModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="deleteModalLabel">Confirm Deletion</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                Are you sure you want to delete this post?
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                <a href="<?= ROOT ?>/user/post/delete/<?= $id ?>" class="btn btn-danger">Delete</a>
            </div>
        </div>
    </div>
</div>

<!-- JavaScript for Edit and Delete -->
<script>
   document.addEventListener("DOMContentLoaded", function () {
    // Show edit form when clicking the edit button
    document.querySelectorAll(".edit-btn").forEach(btn => {
        btn.addEventListener("click", function () {
            let commentId = this.getAttribute("data-id");
            document.getElementById("comment-text-" + commentId).classList.add("d-none");
            document.getElementById("edit-form-" + commentId).classList.remove("d-none");
        });
    });

    // Cancel edit and revert back to original comment
    document.querySelectorAll(".cancel-edit").forEach(button => {
        button.addEventListener("click", function () {
            let form = this.closest(".edit-comment-form");
            let commentId = form.getAttribute("data-id");
            
            document.getElementById("comment-text-" + commentId).classList.remove("d-none");
            form.classList.add("d-none");
        });
    });
});

</script>
<!--blog-->
